#include "SimpleCsoundTest.h"

bool USimpleCsoundTest::Init(int32& SampleRate)
{
	NumChannels = 1;

	csound.reset(new Csound());
	csCompileResult = csound->Compile("C:\\Users\\rory\\sourcecode\\UE4Projects\\CsoundTest\\test.csd");
	if (csCompileResult == 0) // compiled OK...
	{
		CSspout = csound->GetSpout();
		CSspin = csound->GetSpin();
	}

	return true;
}

int32 USimpleCsoundTest::OnGenerateAudio(float* OutAudio, int32 NumSamples)
{
	for (int32 Sample = 0; Sample < NumSamples; ++Sample, ksmpsIndex++)
	{
		if (ksmpsIndex == csound->GetKsmps())
		{
			csCompileResult = csound->PerformKsmps();
			if(csCompileResult == 0)
				ksmpsIndex = 0;
		}

		OutAudio[Sample] = CSspout[ksmpsIndex];
	}
	return NumSamples;
}

void USimpleCsoundTest::SetFrequency(const float InFrequencyHz)
{

}

void USimpleCsoundTest::SendScoreEvent(const FString event)
{
	if (event.IsEmpty())
		return;

	csound->InputMessage(TCHAR_TO_ANSI(*event));
}

void USimpleCsoundTest::SetControlChannel(const FString channel, float value)
{
	csound->SetControlChannel(TCHAR_TO_ANSI(*channel), value);
}
